import { IRelativePattern } from '../../base/common/glob.js';

interface LanguageFilter {
    readonly language?: string;
    readonly scheme?: string;
    readonly pattern?: string | IRelativePattern;
    readonly notebookType?: string;
    /**
     * This provider is implemented in the UI thread.
     */
    readonly hasAccessToAllModels?: boolean;
    readonly exclusive?: boolean;
    /**
     * This provider comes from a builtin extension.
     */
    readonly isBuiltin?: boolean;
}
type LanguageSelector = string | LanguageFilter | ReadonlyArray<string | LanguageFilter>;

export type { LanguageFilter, LanguageSelector };
