import { localize } from '../../nls.js';

var AccessibilityHelpNLS;
( ((function(AccessibilityHelpNLS) {
    AccessibilityHelpNLS.accessibilityHelpTitle = ( localize(743, "Accessibility Help"));
    AccessibilityHelpNLS.openingDocs = ( localize(744, "Opening the Accessibility documentation page."));
    AccessibilityHelpNLS.readonlyDiffEditor = ( localize(745, "You are in a read-only pane of a diff editor."));
    AccessibilityHelpNLS.editableDiffEditor = ( localize(746, "You are in a pane of a diff editor."));
    AccessibilityHelpNLS.readonlyEditor = ( localize(747, "You are in a read-only code editor."));
    AccessibilityHelpNLS.editableEditor = ( localize(748, "You are in a code editor."));
    AccessibilityHelpNLS.changeConfigToOnMac = ( localize(
        749,
        "Configure the application to be optimized for usage with a Screen Reader (Command+E)."
    ));
    AccessibilityHelpNLS.changeConfigToOnWinLinux = ( localize(
        750,
        "Configure the application to be optimized for usage with a Screen Reader (Control+E)."
    ));
    AccessibilityHelpNLS.auto_on = ( localize(
        751,
        "The application is configured to be optimized for usage with a Screen Reader."
    ));
    AccessibilityHelpNLS.auto_off = ( localize(
        752,
        "The application is configured to never be optimized for usage with a Screen Reader."
    ));
    AccessibilityHelpNLS.screenReaderModeEnabled = ( localize(753, "Screen Reader Optimized Mode enabled."));
    AccessibilityHelpNLS.screenReaderModeDisabled = ( localize(754, "Screen Reader Optimized Mode disabled."));
    AccessibilityHelpNLS.tabFocusModeOnMsg = ( localize(
        755,
        "Pressing Tab in the current editor will move focus to the next focusable element. Toggle this behavior{0}.",
        '<keybinding:editor.action.toggleTabFocusMode>'
    ));
    AccessibilityHelpNLS.tabFocusModeOffMsg = ( localize(
        756,
        "Pressing Tab in the current editor will insert the tab character. Toggle this behavior{0}.",
        '<keybinding:editor.action.toggleTabFocusMode>'
    ));
    AccessibilityHelpNLS.stickScroll = ( localize(
        757,
        "Focus Sticky Scroll{0} to focus the currently nested scopes.",
        '<keybinding:editor.action.focusStickyDebugConsole>'
    ));
    AccessibilityHelpNLS.codeFolding = ( localize(
        758,
        "Use code folding to collapse blocks of code and focus on the code you're interested in via the Toggle Folding Command{0}.",
        '<keybinding:editor.toggleFold>'
    ));
    AccessibilityHelpNLS.intellisense = ( localize(
        759,
        "Use Intellisense to improve coding efficiency and reduce errors. Trigger suggestions{0}.",
        '<keybinding:editor.action.triggerSuggest>'
    ));
    AccessibilityHelpNLS.showOrFocusHover = ( localize(
        760,
        "Show or focus the hover{0} to read information about the current symbol.",
        '<keybinding:editor.action.showHover>'
    ));
    AccessibilityHelpNLS.goToSymbol = ( localize(
        761,
        "Go to Symbol{0} to quickly navigate between symbols in the current file.",
        '<keybinding:workbench.action.gotoSymbol>'
    ));
    AccessibilityHelpNLS.showAccessibilityHelpAction = ( localize(762, "Show Accessibility Help"));
    AccessibilityHelpNLS.listSignalSounds = ( localize(
        763,
        "Run the command: List Signal Sounds for an overview of all sounds and their current status."
    ));
    AccessibilityHelpNLS.listAlerts = ( localize(
        764,
        "Run the command: List Signal Announcements for an overview of announcements and their current status."
    ));
    AccessibilityHelpNLS.quickChat = ( localize(
        765,
        "Toggle quick chat{0} to open or close a chat session.",
        '<keybinding:workbench.action.quickchat.toggle>'
    ));
    AccessibilityHelpNLS.startInlineChat = ( localize(
        766,
        "Start inline chat{0} to create an in editor chat session.",
        '<keybinding:inlineChat.start>'
    ));
    AccessibilityHelpNLS.startDebugging = ( localize(
        767,
        "The Debug: Start Debugging command{0} will start a debug session.",
        '<keybinding:workbench.action.debug.start>'
    ));
    AccessibilityHelpNLS.setBreakpoint = ( localize(
        768,
        "The Debug: Inline Breakpoint command{0} will set or unset a breakpoint at the current cursor position in the active editor.",
        '<keybinding:editor.debug.action.toggleInlineBreakpoint>'
    ));
    AccessibilityHelpNLS.addToWatch = ( localize(
        769,
        "The Debug: Add to Watch command{0} will add the selected text to the watch view.",
        '<keybinding:editor.debug.action.selectionToWatch>'
    ));
    AccessibilityHelpNLS.debugExecuteSelection = ( localize(
        770,
        "The Debug: Execute Selection command{0} will execute the selected text in the debug console.",
        '<keybinding:editor.debug.action.selectionToRepl>'
    ));
})(AccessibilityHelpNLS || (AccessibilityHelpNLS = {}))));
var InspectTokensNLS;
( ((function(InspectTokensNLS) {
    InspectTokensNLS.inspectTokensAction = ( localize(771, "Developer: Inspect Tokens"));
})(InspectTokensNLS || (InspectTokensNLS = {}))));
var StandaloneCodeEditorNLS;
( ((function(StandaloneCodeEditorNLS) {
    StandaloneCodeEditorNLS.editorViewAccessibleLabel = ( localize(778, "Editor content"));
})(StandaloneCodeEditorNLS || (StandaloneCodeEditorNLS = {}))));
var ToggleHighContrastNLS;
( ((function(ToggleHighContrastNLS) {
    ToggleHighContrastNLS.toggleHighContrast = ( localize(779, "Toggle High Contrast Theme"));
})(ToggleHighContrastNLS || (ToggleHighContrastNLS = {}))));
var StandaloneServicesNLS;
( ((function(StandaloneServicesNLS) {
    StandaloneServicesNLS.bulkEditServiceSummary = ( localize(780, "Made {0} edits in {1} files"));
})(StandaloneServicesNLS || (StandaloneServicesNLS = {}))));

export { AccessibilityHelpNLS, InspectTokensNLS, StandaloneCodeEditorNLS, StandaloneServicesNLS, ToggleHighContrastNLS };
