import { localize } from '../../../../nls.js';
import { Color, RGBA } from '../../../../base/common/color.js';
import { registerColor, oneOf } from '../colorUtils.js';
import { editorWidgetBackground, editorWidgetForeground } from './editorColors.js';
import { listActiveSelectionForeground, listActiveSelectionIconForeground, listActiveSelectionBackground } from './listColors.js';

const quickInputBackground = registerColor('quickInput.background', editorWidgetBackground, ( localize(
 3609,
 "Quick picker background color. The quick picker widget is the container for pickers like the command palette."
)));
const quickInputForeground = registerColor('quickInput.foreground', editorWidgetForeground, ( localize(
 3610,
 "Quick picker foreground color. The quick picker widget is the container for pickers like the command palette."
)));
const quickInputTitleBackground = registerColor('quickInputTitle.background', { dark: ( (new Color( (new RGBA(255, 255, 255, 0.105))))), light: ( (new Color( (new RGBA(0, 0, 0, 0.06))))), hcDark: '#000000', hcLight: Color.white }, ( localize(
 3611,
 "Quick picker title background color. The quick picker widget is the container for pickers like the command palette."
)));
const pickerGroupForeground = registerColor('pickerGroup.foreground', { dark: '#3794FF', light: '#0066BF', hcDark: Color.white, hcLight: '#0F4A85' }, ( localize(3612, "Quick picker color for grouping labels.")));
const pickerGroupBorder = registerColor('pickerGroup.border', { dark: '#3F3F46', light: '#CCCEDB', hcDark: Color.white, hcLight: '#0F4A85' }, ( localize(3613, "Quick picker color for grouping borders.")));
const _deprecatedQuickInputListFocusBackground = registerColor('quickInput.list.focusBackground', null, '', undefined, ( localize(3614, "Please use quickInputList.focusBackground instead")));
const quickInputListFocusForeground = registerColor('quickInputList.focusForeground', listActiveSelectionForeground, ( localize(3615, "Quick picker foreground color for the focused item.")));
const quickInputListFocusIconForeground = registerColor('quickInputList.focusIconForeground', listActiveSelectionIconForeground, ( localize(3616, "Quick picker icon foreground color for the focused item.")));
const quickInputListFocusBackground = registerColor('quickInputList.focusBackground', { dark: oneOf(_deprecatedQuickInputListFocusBackground, listActiveSelectionBackground), light: oneOf(_deprecatedQuickInputListFocusBackground, listActiveSelectionBackground), hcDark: null, hcLight: null }, ( localize(3617, "Quick picker background color for the focused item.")));

export { _deprecatedQuickInputListFocusBackground, pickerGroupBorder, pickerGroupForeground, quickInputBackground, quickInputForeground, quickInputListFocusBackground, quickInputListFocusForeground, quickInputListFocusIconForeground, quickInputTitleBackground };
