import { Codicon } from '../../../../base/common/codicons.js';
import { localize } from '../../../../nls.js';
import { registerIcon } from '../../../../platform/theme/common/iconRegistry.js';

const searchDetailsIcon = registerIcon('search-details', Codicon.ellipsis, ( localize(8468, 'Icon to make search details visible.')));
const searchActivityBarIcon = registerIcon('search-see-more', Codicon.goToSearch, ( localize(8469, 'Icon to view more context in the search view.')));
const searchShowContextIcon = registerIcon('search-show-context', Codicon.listSelection, ( localize(8470, 'Icon for toggle the context in the search editor.')));
const searchHideReplaceIcon = registerIcon('search-hide-replace', Codicon.chevronRight, ( localize(8471, 'Icon to collapse the replace section in the search view.')));
const searchShowReplaceIcon = registerIcon('search-show-replace', Codicon.chevronDown, ( localize(8472, 'Icon to expand the replace section in the search view.')));
const searchReplaceAllIcon = registerIcon('search-replace-all', Codicon.replaceAll, ( localize(8473, 'Icon for replace all in the search view.')));
const searchReplaceIcon = registerIcon('search-replace', Codicon.replace, ( localize(8474, 'Icon for replace in the search view.')));
const searchRemoveIcon = registerIcon('search-remove', Codicon.close, ( localize(8475, 'Icon to remove a search result.')));
const searchRefreshIcon = registerIcon('search-refresh', Codicon.refresh, ( localize(8476, 'Icon for refresh in the search view.')));
const searchCollapseAllIcon = registerIcon('search-collapse-results', Codicon.collapseAll, ( localize(8477, 'Icon for collapse results in the search view.')));
const searchExpandAllIcon = registerIcon('search-expand-results', Codicon.expandAll, ( localize(8478, 'Icon for expand results in the search view.')));
const searchShowAsTree = registerIcon('search-tree', Codicon.listTree, ( localize(8479, 'Icon for viewing results as a tree in the search view.')));
const searchShowAsList = registerIcon('search-list', Codicon.listFlat, ( localize(8480, 'Icon for viewing results as a list in the search view.')));
const searchClearIcon = registerIcon('search-clear-results', Codicon.clearAll, ( localize(8481, 'Icon for clear results in the search view.')));
const searchStopIcon = registerIcon('search-stop', Codicon.searchStop, ( localize(8482, 'Icon for stop in the search view.')));
const searchViewIcon = registerIcon('search-view-icon', Codicon.search, ( localize(8483, 'View icon of the search view.')));
const searchNewEditorIcon = registerIcon('search-new-editor', Codicon.newFile, ( localize(8484, 'Icon for the action to open a new search editor.')));
const searchOpenInFileIcon = registerIcon('search-open-in-file', Codicon.goToFile, ( localize(
 8485,
 'Icon for the action to go to the file of the current search result.'
)));
registerIcon('search-sparkle-filled', Codicon.sparkleFilled, ( localize(8486, 'Icon to show AI results in search.')));
registerIcon('search-sparkle-empty', Codicon.sparkle, ( localize(8487, 'Icon to hide AI results in search.')));

export { searchActivityBarIcon, searchClearIcon, searchCollapseAllIcon, searchDetailsIcon, searchExpandAllIcon, searchHideReplaceIcon, searchNewEditorIcon, searchOpenInFileIcon, searchRefreshIcon, searchRemoveIcon, searchReplaceAllIcon, searchReplaceIcon, searchShowAsList, searchShowAsTree, searchShowContextIcon, searchShowReplaceIcon, searchStopIcon, searchViewIcon };
