import { localize } from '../../../../nls.js';

function applyDeprecatedVariableMessage(schema) {
    schema.pattern = schema.pattern || '^(?!.*\\$\\{(env|config|command)\\.)';
    schema.patternErrorMessage = schema.patternErrorMessage ||
        ( localize(
         10706,
         "'env.', 'config.' and 'command.' are deprecated, use 'env:', 'config:' and 'command:' instead."
        ));
}

export { applyDeprecatedVariableMessage };
