import { ServiceIdentifier } from '../../../../platform/instantiation/common/instantiation.js';
import { IWorkbenchEnvironmentService } from '../common/environmentService.service.js';
import { IWorkbenchConstructionOptions } from '../../../browser/web.api.js';

declare const IBrowserWorkbenchEnvironmentService: ServiceIdentifier<IBrowserWorkbenchEnvironmentService>;
/**
* A subclass of the `IWorkbenchEnvironmentService` to be used only environments
* where the web API is available (browsers, Electron).
*/
interface IBrowserWorkbenchEnvironmentService extends IWorkbenchEnvironmentService {
    /**
    * Options used to configure the workbench.
    */
    readonly options?: IWorkbenchConstructionOptions;
    /**
    * Gets whether a resolver extension is expected for the environment.
    */
    readonly expectsResolverExtension: boolean;
}

export { IBrowserWorkbenchEnvironmentService };
